collaborators = 'Your collaborators here'

# Answer True or False for each part of problem 1.
answer_for_problem_1_part_a = None
answer_for_problem_1_part_b = None
answer_for_problem_1_part_c = None
answer_for_problem_1_part_d = None
answer_for_problem_1_part_e = None
answer_for_problem_1_part_f = None
answer_for_problem_1_part_g = None

# On problem 2, your answer to part a) should be a boolean, your to part b)
# should be an integer, and your answer to part c) should be a string.
answer_for_problem_2_part_a = None
answer_for_problem_2_part_b = 0
answer_for_problem_2_part_c = 'Type your proof here.'

# Enter your answer to problem 3 here.
answer_for_problem_3 = '''
I have found a beautiful algorithm for this problem, but this tweet is not
large enough to contain it.
'''

# -- Problem 4 code begins here. You need to finish the last function. --

# Rotates the polyomino 90 degrees counterclockwise. Returns a new list.
def rotate(polyomino):
  return [(-y, x) for (x, y) in polyomino]

# Translates the polyomino by the offset. Returns a new list.
def translate(polyomino, offset):
  return [(x + offset[0], y + offset[1]) for (x, y) in polyomino]

# Checks if two polyominoes are equivalent under rotation and translation. Runs
# in linear time in the size of the two polyominoes.
def compare(poly1, poly2):
  if len(poly1) != len(poly2):
    return False

  # Translates a polyomino so that it just touches the x and y axes. Returns the
  # set of squares in the translated shape.
  def get_canonical_set(polyomino):
    offset = (-min(x for (x, y) in polyomino), -min(y for (x, y) in polyomino))
    return set(translate(polyomino, offset))

  poly1_set = get_canonical_set(poly1)
  for i in range(4):
    poly2_set = get_canonical_set(poly2)
    if poly1_set == poly2_set:
      return True
    poly2 = rotate(poly2)

  return False

# Fill in the body of this function for Problem 4.
def num_proteins_in_common(protein_list1, protein_list2):
  pass
